﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO.Ports;  //시리얼통신을 위해 추가해줘야 함
using System.Threading;
using System.Text.RegularExpressions;

namespace Serial_Communication
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)  //폼이 로드되면
        {
            comboBox_port.DataSource = SerialPort.GetPortNames(); //연결 가능한 시리얼포트 이름을 콤보박스에 가져오기 
            comboBox_baud.SelectedIndex = 0;
            Bitmap sourceImage = global::SwitchModule_SW.Properties.Resources.withwave_logo_1;// new Bitmap(@"D:\earth.png");
            int width = sourceImage.Width / 4; 
            int height = sourceImage.Height / 4; 
            Size resize = new Size(width, height); 
            Bitmap resizeImage = new Bitmap(sourceImage, resize);
            Logo.Image = resizeImage;
            gb_RF.Enabled = false;
            button_close.Enabled = false;
            button_send.Enabled = false;
        }
               
        private void Button_open_Click(object sender, EventArgs e)  //통신 연결하기 버튼
        {
            if (!serialPort1.IsOpen)  //시리얼포트가 열려 있지 않으면
            {
                serialPort1.PortName = comboBox_port.Text;  //콤보박스의 선택된 COM포트명을 시리얼포트명으로 지정
                serialPort1.BaudRate = Int32.Parse(comboBox_baud.Text);  //보레이트 변경이 필요하면 숫자 변경하기
                serialPort1.DataBits = 8;
                serialPort1.StopBits = StopBits.One;
                serialPort1.Parity = Parity.None;
                serialPort1.DtrEnable = true;
                serialPort1.DataReceived += new SerialDataReceivedEventHandler(serialPort1_DataReceived); //이것이 꼭 필요하다
                serialPort1.Open();  //시리얼포트 열기
                comboBox_port.Enabled = false;  //COM포트설정 콤보박스 비활성화
                comboBox_baud.Enabled = false;  //COM포트설정 콤보박스 비활성화
                gb_RF.Enabled = true;
                button_close.Enabled = true;
                button_send.Enabled = true;

                string command = "*IDN?;";
                serialPort1.WriteLine(command);  //텍스트박스의 텍스트를 시리얼통신으로 송신
                Thread.Sleep(100);
                string sData = serialPort1.ReadExisting();
                if (sData != null)
                {
                    string[] result = sData.Split(new char[] { ',','\r' });
                    string[] numbers = Regex.Split(result[0], @"\D+");
                    int spxt = 0;
                    int freq = 0;
                    foreach (string value in numbers)
                    {
                        if (!string.IsNullOrEmpty(value))
                        {
                            int num = int.Parse(value);
                            if (num > 100)
                            {
                                spxt = int.Parse(value.Substring(0, value.Length - 2));
                                freq = int.Parse(value.Substring(value.Length - 2, 2));
                                break;
                            }
                            else spxt = num;
                        }
                    }
                    if (freq == 0)
                    {
                        Model.Text = result[0] + "," + result[4] + " ," + spxt.ToString() + "-Port Matrix Switch";
                        RadioButton1.Enabled = false; RadioButton2.Enabled = false; RadioButton3.Enabled = false; RadioButton4.Enabled = false;
                        RadioButton5.Enabled = false; RadioButton6.Enabled = false; RadioButton7.Enabled = false; RadioButton8.Enabled = false;
                        RadioButton9.Enabled = false; RadioButton10.Enabled = false; RadioButton11.Enabled = false; RadioButton12.Enabled = false;
                    }
                    else
                    {
                        Model.Text = result[0] + "," + result[4] + " ,SP" + spxt.ToString() + "T, " + freq.ToString() + "GHz";
                        RadioButton13.Enabled = false; RadioButton14.Enabled = false; RadioButton15.Enabled = false; RadioButton16.Enabled = false;
                        RadioButton17.Enabled = false; RadioButton18.Enabled = false;
                        switch (spxt)
                        {
                            case 4:
                                RadioButton5.Enabled = false; RadioButton6.Enabled = false; RadioButton7.Enabled = false; RadioButton8.Enabled = false;
                                RadioButton9.Enabled = false; RadioButton10.Enabled = false; RadioButton11.Enabled = false; RadioButton12.Enabled = false;
                                break;
                            case 8:
                                RadioButton9.Enabled = false; RadioButton10.Enabled = false; RadioButton11.Enabled = false; RadioButton12.Enabled = false;
                                break;
                            case 10:
                                RadioButton11.Enabled = false; RadioButton12.Enabled = false;
                                break;
                            default:
                                break;
                        }
                    }
                }
            }

        }

        private void serialPort1_DataReceived(object sender, SerialDataReceivedEventArgs e)  //수신 이벤트가 발생하면 이 부분이 실행된다.
        {
            this.Invoke(new EventHandler(MySerialReceived));  //메인 쓰레드와 수신 쓰레드의 충돌 방지를 위해 Invoke 사용. MySerialReceived로 이동하여 추가 작업 실행.
        }

        private void MySerialReceived(object s, EventArgs e)  //여기에서 수신 데이타를 사용자의 용도에 따라 처리한다.
        {
            string sData = serialPort1.ReadExisting();  //시리얼 버터에 수신된 데이타를 ReceiveData 읽어오기
            richTextBox_received.Text = richTextBox_received.Text + sData;  //int 형식을 string형식으로 변환하여 출력
            richTextBox_received.Focus();
            richTextBox_received.Select(richTextBox_received.Text.Length, 0);
        }


        private void Button_send_Click(object sender, EventArgs e)  //보내기 버튼을 클릭하면
        {
            string command = comboBox_command.Text;
            serialPort1.WriteLine(command);  //텍스트박스의 텍스트를 시리얼통신으로 송신
            if (command == "RESET;")
            {
                Button_close_Click(sender, e);
            }
        }

        private void Button_close_Click(object sender, EventArgs e)  //통신 연결끊기 버튼
        {
            if (serialPort1.IsOpen)  //시리얼포트가 열려 있으면
            {
                serialPort1.Close();  //시리얼포트 닫기
            }
            comboBox_port.Enabled = true;  //COM포트설정 콤보박스 활성화
            comboBox_baud.Enabled = true;  //COM포트설정 콤보박스 활성화
            gb_RF.Enabled = false;
            button_close.Enabled = false;
            button_send.Enabled = false;
        }

        private void comboBox_port_MouseClick(object sender, MouseEventArgs e)
        {
            comboBox_port.DataSource = SerialPort.GetPortNames(); //연결 가능한 시리얼포트 이름을 콤보박스에 가져오기 
        }

        private void button_refresh_Click(object sender, EventArgs e)
        {
            comboBox_port.DataSource = SerialPort.GetPortNames(); //연결 가능한 시리얼포트 이름을 콤보박스에 가져오기 
        }

        private void RadioRF_Click(object sender, EventArgs e)
        {
            RadioButton radioControl = (RadioButton)sender;
            int index = comboBox_command.FindString(radioControl.Tag.ToString());
            comboBox_command.SelectedIndex = index;
            Button_send_Click(sender, e);
        }
    }
}
